package net.pingex.dcf;

import net.pingex.dcf.core.Configuration;
import net.pingex.dcf.core.GatewayConnectionsManager;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import sx.blah.discord.api.ClientBuilder;

/**
 * Main class for DCF
 */
public class DiscordCommandableFramework
{
	/**
	 * Logger
	 */
	private static final Logger LOGGER = LogManager.getLogger(DiscordCommandableFramework.class);

	/**
	 * Main entry point
	 */
	public static void main(String[] args)
	{
		Configuration.load();
		Configuration.init();
		LOGGER.info("Hello World");
		LOGGER.info(Configuration.BOT_NAME);
		LOGGER.info("Framework version {}", DiscordCommandableFramework.class.getPackage().getImplementationVersion() != null ? DiscordCommandableFramework.class.getPackage().getImplementationVersion() : "UNKNOWN");

		// Set up initial connection
		ClientBuilder builder = new ClientBuilder();
		if(Configuration.isConnectionToken())	builder.withToken(Configuration.CONNECTION_TOKEN);
		else									builder.withLogin(Configuration.CONNECTION_USERNAME, Configuration.CONNECTION_PASSWORD);
		GatewayConnectionsManager.getInstance().registerConnection(builder);
	}
}
